var info = {
    addListeners: function(evt){
        content.document.body.addEventListener("mouseover", function(e){
            info.curEvt = e.originalTarget;
        }, true);
        var aPile = content.document.links;
        for (i = 0; i < aPile.length; i++) {
            if (aPile[i].href.search(/user_id=[\d]{5,10}/gi) != -1 && aPile[i].href.indexOf('profile') != -1) {
			    var img = content.document.createElement('img');
				img.src = "chrome://mobtools/skin/images/anchor.png";
			    var bullet = aPile[i].appendChild(img);
                bullet.addEventListener("mouseover", function(e){
                    info.handler(e);
                }, false);
                bullet.addEventListener("mouseout", function(e){
                    info.remove(e);
                }, false);
            }
        }
    },
    handler: function(evt){
        if (!this.status) 
            return;
        if (this.previous == evt.target.parentNode.getAttribute('href')) {
            this.show();
            return;
        }
        this.status = false;
        this.evt = evt;
        var id = evt.target.parentNode.getAttribute('href').match(/[\d]{5,10}/gi);
        if (content.document.getElementById("hoverDiv") == null) 
            this.create();
        this.getData(id[0]);
    },
    show: function(){
        var document = content.document;
        var e = this.evt;
        if (e.target != this.curEvt) 
            return;
        hoverDiv = document.getElementById("hoverDiv");
        hoverDiv.style.display = 'block';
        posX = e.clientX;
        posY = e.clientY;
        ((document.body.clientWidth - posX) < hoverDiv.clientWidth) ? hoverDiv.style.left = posX - hoverDiv.clientWidth + 'px' : hoverDiv.style.left = posX + 'px';
        ((document.body.clientHeight - posY) < hoverDiv.clientHeight) ? hoverDiv.style.top = posY - hoverDiv.clientHeight + 'px' : hoverDiv.style.top = posY + 'px';
        this.status = true;
    },
    update: function(profileData){
        var document = content.document;
		div = profileData.match(/<div[\s\S]+(?=<\/div)/gi);
		var profileRange = document.createRange();
		profileRange.selectNode(document.body);
		var profileFrag = profileRange.createContextualFragment(div[0]).childNodes[0];
		var statContainer = profileFrag.childNodes[7].childNodes[3].childNodes[1].childNodes[11];
        var bounty = profileData.match(/\$[\d,]+(?=")/gi);
        document.getElementById("bountyDiv").textContent = bounty[0];
        var range = document.createRange();
        range.selectNode(document.body);
        document.getElementById("userDiv").textContent = profileFrag.childNodes[7].childNodes[3].childNodes[1].childNodes[3].textContent;
		document.getElementById("statusDiv").textContent = profileFrag.childNodes[7].childNodes[3].childNodes[1].childNodes[7].textContent;
        userStats = profileFrag.childNodes[7].childNodes[3].childNodes[1].childNodes[11];
		if(userStats == null) return;
        userStats.setAttribute("id", "userStatsTab");
        hoverDiv = document.getElementById("hoverDiv");
        if (document.getElementById("userStatsTab") != null) 
            document.getElementById("userDiv").parentNode.removeChild(document.getElementById("userStatsTab"));
        hoverDiv.appendChild(userStats);
        this.show();
    },
    remove: function(e){
        (content.document.getElementById("hoverDiv") != null) ? content.document.getElementById("hoverDiv").style.display = 'none' : '';
    },
    reqObject: new XMLHttpRequest(),
    getData: function(id){
        var xh = this.reqObject;
        if (xh) {
            xh.open("GET", "http://75.101.250.145/profile/?user_id=" + id, true);
            xh.onreadystatechange = function(){
                if (xh.readyState == 4) {
                    if (xh.status == 200) {
                        xh.onreadystatechange = null;
                        var profileData = xh.responseText;
						profileData = profileData.replace(/content/gi,'stats');
                        xh.open("GET", 'http://75.101.250.145/hitlist/add.php?from=profile&target_id=' + id, true);
                        xh.onreadystatechange = function(){
                            if (xh.readyState == 4) {
                                if (xh.status == 200) {
                                    profileData = profileData + xh.responseText;
                                    info.update(profileData);
                                    info.previous = info.evt.target.parentNode.getAttribute('href');
                                }
                            }
                        };
                        xh.send(null);
                    }
                }
            };
            xh.send(null);
        }
        else {
            return;
        }
    },
    evt: null,
    previous: null,
    curEvt: null,
    status: true,
    create: function(){
        hoverDiv = content.document.createElement('div');
        hoverDiv.setAttribute("id", "hoverDiv");
        userDiv = content.document.createElement('div');
        userDiv.setAttribute("id", "userDiv");
        hoverDiv.appendChild(userDiv);
        statusDiv = content.document.createElement('div');
        statusDiv.setAttribute("id", "statusDiv");
        hoverDiv.appendChild(statusDiv);		
        bountyDiv = document.createElement("div");
        bountyDiv.setAttribute("id", "bountyDiv");
        hoverDiv.appendChild(bountyDiv);
        ss = content.document.styleSheets[0];
        ss.insertRule("#hoverDiv { background-color: #111;border:solid 2px #c0c0c0;position:fixed; display:none;font: .75em Tahoma;color:#fff }", 0);
        ss.insertRule("#userDiv { padding:2px;font: 2em Tahoma;color:#fff }", 0);
        ss.insertRule("#bountyDiv { padding:2px;font: 2em Tahoma;color:#ff0000 }", 0);
        ss.insertRule("#userStatsTab { white-space:nowrap }", 0);
        ss.insertRule("#userStatsTab table td + td { color : #ff0000 }", 0);
        content.document.body.appendChild(hoverDiv);
    },
};
