/* ***** BEGIN LICENSE BLOCK *****
* Version: MPL 1.1/GPL 2.0/LGPL 2.1
*
* The contents of this file are subject to the Mozilla Public License Version
* 1.1 (the "License"); you may not use this file except in compliance with
* the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
* 
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is Mob Tools.
*
* The Initial Developer of the Original Code is
* James Travis.
* Portions created by the Initial Developer are Copyright (C) 2008
* the Initial Developer. All Rights Reserved.
*
* Contributor(s):
*
* Alternatively, the contents of this file may be used under the terms of
* either the GNU General Public License Version 2 or later (the "GPL"), or
* the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
* in which case the provisions of the GPL or the LGPL are applicable instead
* of those above. If you wish to allow use of your version of this file only
* under the terms of either the GPL or the LGPL, and not to allow others to
* use your version of this file under the terms of the MPL, indicate your
* decision by deleting the provisions above and replace them with the notice
* and other provisions required by the GPL or the LGPL. If you do not delete
* the provisions above, a recipient may use your version of this file under
* the terms of any one of the MPL, the GPL or the LGPL.
* 
* ***** END LICENSE BLOCK ***** */


var mobwars = {
   prefs: null,
   onLoad : function() {
        this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("extensions.mobtools.");
     this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
      this.initialized = true; 
      this.strings = document.getElementById("mobtools-strings"); 
      document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", function(e) {
         mobwars.showContextMenu(e); }
      , false); 
	  var rulesObserver = new PrefListener("extensions.mobtools.",
                                  function(branch, name)
                                  {
                                      switch (name) 
                                      {
                                          case "style.rules":
                                              rw.wFile('mw.css',mobwars.prefs.getCharPref(name),'');
											  style.remove();
											  style.add();
                                              break;
                                      }
                                  });
rulesObserver.register();
      }
   , showContextMenu : function(event) {
   var c = [
   ['context-mobtools-moddrops','gBrowser.mCurrentBrowser.currentURI.spec.indexOf("/city") == - 1 && gBrowser.mCurrentBrowser.currentURI.spec.indexOf("/stockpile") == - 1'],
   ['context-mobtools-removeinvites','gBrowser.mCurrentBrowser.currentURI.spec.indexOf("/mob/") == - 1'],
   ['context-mobtools-punch','!mobwars.hasID()'],
   ['context-mobtools-attack','!mobwars.hasID()'],
   ['context-mobtools-hitlist','!mobwars.hasID()'],
   ['context-mobtools-viewmw','!mobwars.hasID()'],
   ['context-mobtools-viewfb','!mobwars.hasID()'],
   ['context-mobtools-remove','!mobwars.hasID()'],
   ['context-mobtools-add','!mobwars.hasID()'],
   ['context-mobtools-msg','!mobwars.hasID()'],
   ];
   this.filterMenu(c);
      },
    filterMenu : function(a) {
	for(i=0;i<a.length;i++) {
       document.getElementById(a[i][0]).disabled = eval(a[i][1]); 
	}
      
},	
hasID : function () {
var urx = /[\d]{5,10}/; 
if(gContextMenu.onLink) {
return urx.test(gContextMenu.linkURL)
} else if(gContextMenu.isTextSelected) {
var selectedText = window.content.getSelection().toString();
return urx.test(selectedText)
}
},
}; 


window.addEventListener("load", function(e) {
mobwars.onLoad(e);
gBrowser.addEventListener("load", function(e) {
   if (e.originalTarget instanceof HTMLDocument) {
   if (e.originalTarget.defaultView.frameElement) return; 

   (mobwars.prefs.getBoolPref("tools.eventlogging.enable")) ? eventLog.handler() : '';
   if(gBrowser.mCurrentBrowser.currentURI.spec.indexOf('facebook.com/mobwars/') != - 1 && mobwars.prefs.getBoolPref("tools.direct.enable")) {
   path = (gBrowser.mCurrentBrowser.currentURI.path).replace('/mobwars','');
   content.document.location.href = 'http://75.101.250.145' + path;
   return;
   }   
   mobwars.prefs.getBoolPref("tools.direct.enable") ? mobtools.prepDirect() : '';
   (mobwars.prefs.getBoolPref("tools.linkhover.enable")) ? info.addListeners(e) : '';
   status = getStatus();
   (mobwars.prefs.getBoolPref("style.enable")) ? style.add() : '';
(gBrowser.mCurrentBrowser.currentURI.spec.indexOf('/hitlist') != - 1 && gBrowser.mCurrentBrowser.currentURI.spec.indexOf('add') == -1) ? spam.spamify() : '';
   (mobwars.prefs.getBoolPref("helpers.health.enable")) ? health.handler() : '';
	  (gBrowser.mCurrentBrowser.currentURI.spec.indexOf('/hitlist') != - 1 && gBrowser.mCurrentBrowser.currentURI.spec.indexOf('add') == -1 && (mobwars.prefs.getBoolPref("helpers.sticky.enable"))) ? stickyAttack.handler() : '';
	  }
   }
, true);
}
, false); 



